CREATE OR REPLACE TRIGGER LOG_SUP_PRODFORNCOMP
AFTER INSERT OR UPDATE OR DELETE
ON PRODFORNCOMP FOR EACH ROW
DECLARE
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_DESC         VARCHAR2(1500);
   V_CDFILLOGOPER VARCHAR2(4);
   V_ITPESQ       VARCHAR2(80);
   V_NMOPERADOR   VARCHAR2(40);
   V_IDTIPOOPER   VARCHAR2(1);

BEGIN
   /* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      IF (NVL(:OLD.VRARREDCMPFO, 0) <> NVL(:NEW.VRARREDCMPFO, 0)) THEN
         V_DESC := V_DESC || 'Vr. Arred.: Forn.: ' ||''|| NVL(:NEW.VRARREDCMPFO,0) ||'   ';
      END IF;
      IF (NVL(:OLD.VRPERPIPRFO, 0) <> NVL(:NEW.VRPERPIPRFO, 0)) THEN
         V_DESC := V_DESC || 'PI/DSV(%): ' ||''|| NVL(:NEW.VRPERPIPRFO, 0) ||'   ';
      END IF;
      IF (NVL(:OLD.CDEXPRODFORN, 'X') <> NVL(:NEW.CDEXPRODFORN, 'X')) THEN
         V_DESC := V_DESC || 'Cd. Externo: ' ||''|| NVL(:NEW.CDEXPRODFORN,'') ||'   ';
      END IF;
      IF (NVL(:OLD.VRARREDEMPE, 0) <> NVL(:NEW.VRARREDEMPE, 0)) THEN
         V_DESC := V_DESC || 'Arred. Emp.: ' ||''|| NVL(:NEW.VRARREDEMPE, 0) ||'   ';
      END IF;
      IF (NVL(:OLD.VRPERVARPREPRFO, 0) <> NVL(:NEW.VRPERVARPREPRFO, 0)) THEN
         V_DESC := V_DESC || '% Variao: ' ||''|| NVL(:NEW.VRPERVARPREPRFO, 0) ||'   ';
      END IF;
      IF (NVL(:OLD.NRDIASVALPRFORN, 'X') <> NVL(:NEW.NRDIASVALPRFORN, 'X')) THEN
         V_DESC := V_DESC || 'Val. Dias:' ||''|| NVL(:NEW.NRDIASVALPRFORN,'') ||'   ';
      END IF;
      V_ITPESQ       := :NEW.CDFORNECED|| :NEW.CDPRODUTO|| :NEW.CDPRODCOMPL;
      V_CDFILLOGOPER := '9999';
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   :=       'Vr. Arred.: Forn.: '    ||''  || NVL(:NEW.VRARREDCMPFO,'')     ||'  '  ||
                           'PI/DSV(%): '              ||''  || NVL(:NEW.VRPERPIPRFO,'')    ||'  '  ||
                           'Cd. Externo: '               ||''  || NVL(:NEW.CDEXPRODFORN,'')    ||'  '  ||
                           'Arred. Emp.: '               ||''  || NVL(:NEW.VRARREDEMPE, 0)    ||'  '  ||
                           '% Variao:'               ||''  || NVL(:NEW.VRPERVARPREPRFO,0)    ||'  '  ||
                           'Val. Dias: '                   ||''  || NVL(:NEW.NRDIASVALPRFORN,'');

         V_ITPESQ       := :NEW.CDFORNECED|| :NEW.CDPRODUTO|| :NEW.CDPRODCOMPL;
         V_CDFILLOGOPER := '9999';
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC  :=     'Vr. Arred.: Forn.: '    ||''  || NVL(:OLD.VRARREDCMPFO,'')     ||'  '  ||
                           'PI/DSV(%): '              ||''  || NVL(:OLD.VRPERPIPRFO,'')    ||'  '  ||
                           'Cd. Externo: '               ||''  || NVL(:OLD.CDEXPRODFORN,'')    ||'  '  ||
                           'Arred. Emp.: '               ||''  || NVL(:OLD.VRARREDEMPE, 0)    ||'  '  ||
                           '% Variao:'               ||''  || NVL(:OLD.VRPERVARPREPRFO,0)    ||'  '  ||
                           'Val. Dias: '                   ||''  || NVL(:OLD.NRDIASVALPRFORN,'');

            V_ITPESQ         := :OLD.CDFORNECED|| :OLD.CDPRODUTO|| :OLD.CDPRODCOMPL;
            V_CDFILLOGOPER   := '9999';
            V_IDTIPOOPER     := '3';
         END IF;
      END IF;
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 400);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('PRODFORNCOMP',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_SUP_PRODFORNCOMP','6.19.XXX'); END;
/